<template>
  <div>
    <div class="d-flex my-3 justify-content-start">
      <button class="btn btn-success btn-md" @click="add()">
        <i class="flaticon-add"></i> Tambah Uraian
      </button>
    </div>

    <div class="table-responsive mt-5">
      <table
        class="table table-head-custom table-vertical-center table-head-bg table-borderless"
      >
        <thead>
          <tr class="text-left">
            <th class="pl-7" style="min-width: 250px">
              <span class="text-dark-75">Uraian</span>
            </th>
            <th style="min-width: 100px">Aksi</th>
          </tr>
        </thead>

        <tbody>
          <template v-for="(description, i) in descriptions">
            <tr v-bind:key="i">
              <td class="pl-0 ">
                <template v-if="currentIndex !== i">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ description.description }}
                  </span>
                </template>

                <template v-if="currentIndex === i">
                  <b-form-input
                    id="input-large"
                    size="lg"
                    v-model="description.description"
                  ></b-form-input>
                </template>
              </td>

              <td class="pl-0 ">
                <a
                  class="btn btn-light-success font-weight-bolder font-size-sm"
                  @click="currentIndex = i"
                  v-if="currentIndex !== i"
                >
                  <i class="flaticon-edit"></i>
                </a>

                <a
                  class="btn btn-light-success font-weight-bolder font-size-sm"
                  @click="currentIndex = null"
                  v-if="currentIndex === i"
                >
                  <i class="flaticon2-cross"></i>
                </a>

                <a
                  class="btn btn-light-danger font-weight-bolder font-size-sm ml-2"
                  @click="remove(i)"
                >
                  <i class="flaticon2-trash"></i>
                </a>
              </td>
            </tr>
          </template>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
export default {
  name: "Description",
  props: {
    descriptions: {
      type: Array,
      default: () => []
    }
  },
  data() {
    return {
      description: {
        id: null,
        description: null
      },
      currentIndex: null
    };
  },
  methods: {
    remove(index) {
      const descriptions = this.descriptions;

      descriptions.splice(index, 1);

      this.$emit("setDescriptions", descriptions);
    },

    add() {
      const descriptions = this.descriptions;

      descriptions.push({
        id: null,
        description: null
      });

      this.$emit("setDescriptions", { scope_of_contract: descriptions });
    },

    update(index, description) {
      const descriptions = this.descriptions;

      descriptions[index] = description;

      this.$emit("setDescriptions", { scope_of_contract: descriptions });
    }
  }
};
</script>
